# All files / utils style.js

84.72% Statements 61/72
80.56% Branches 29/36
83.33% Functions 10/12
83.58% Lines 56/67

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222

    14x

    114x

    146x

    8x

    1x
    1x

    1x

    2x

    4x

    2x

    54x

    54x
    54x
    54x
    54x
    54x

    54x
    18x

    36x
    21x

    15x
    12x
    12x
    12x
    12x
    1x
    1x
    1x
    11x
    7x
    7x
    7x
    4x
    3x
    3x
    3x
    1x
    1x
    1x
    1x

    12x

    3x
    3x

    6x
    6x
    6x

    6x
    3x
    3x

    3x
    3x
    3x

    3x
    3x
    3x

    6x

     // style.js
    import { keyframes } from 'styled-components';
    import { niceCircles } from '.';

    export function truncate(width) {
      return `
        width: ${width};
        white-space: nowrap;
        overflow: hidden;
        text-overflow: ellipsis;
      `;
    }

    export function ellipsis(width) {
      return `
        display: inline-block;
        max-width: ${width};
        overflow: hidden;
        text-overflow: ellipsis;
        white-space: nowrap;
      `;
    }

    export function themeColor(theme, key, variant) {
      return theme.palette.colors[key][variant];
    }

    export function textColor(theme, key, variant) {
      return theme.palette.contrastColors[key][variant];
    }

    export function actionColor(theme, variant) {
      return theme.palette.action[variant];
    }

    export function animate(animationName) {
      let result;
      Eif (animationName === 'slide-in') {
        result = keyframes`
          from {
            opacity: 0;
            transform: translateY(10px);
          }
          to {
            opacity: 1;
            transform: translateY(0);
          }
        `;
      } else if (animationName === 'slide-out') {
        result = keyframes`
          from {
            opacity: 1;
            transform: translateY(0);
          }
          to {
            opacity: 0;
            transform: translateY(10px);
          }
        `;
      }

      return result;
    }
    export function animation(delay, duration, animationName) {
      const innerAnimation = animate(animationName);

      const animateProperty = `
        ${innerAnimation}

        -webkit-animation-delay: ${delay};
        -webkit-animation-duration: ${duration};
        -webkit-animation-name: ${animationName};
        -webkit-animation-fill-mode: forwards; /* this prevents the animation from restarting! */

        -moz-animation-delay: ${delay};
        -moz-animation-duration: ${duration};
        -moz-animation-name: ${animationName};
        -moz-animation-fill-mode: forwards; /* this prevents the animation from restarting! */

        animation-delay: ${delay};
        animation-duration: ${duration};
        animation-name: ${animationName};
        animation-fill-mode: forwards; /* this prevents the animation from restarting! */
      `;

      return animateProperty;
    }

    export function headerMenuButton(size) {
      return `
        cursor: pointer;
        width: ${size};
        height: ${size};
        padding: 8px;
        -webkit-box-sizing: border-box;
        box-sizing: border-box;
        border-radius: 8px;
        display: -webkit-box;
        display: -ms-flexbox;
        display: flex;
        -webkit-box-align: center;
        -ms-flex-align: center;
        align-items: center;
        &:hover {
          background-color: rgba(0,0,0,.1);
        }

        i {
          width: 40px;
        }

      `;
    }

    export function flexRow() {
      return `
        display: flex;
        flex: 1;
        flex-wrap: nowrap;
        flex-direction: column;
      `;
    }

    export function flexColumn() {
      return `
        display: flex;
        flex: 1;
        flex-wrap: nowrap;
        flex-direction: row;
      `;
    }

    // This is used to generate differnet avatar sizes
    export function avatarStyle(element, sizeName) {
      const unit = '8px';
      let sizeValue;
      if (sizeName === 'xsmall') sizeValue = `calc( 4 * ${unit})`;
      if (sizeName === 'small') sizeValue = `calc( 5 * ${unit})`;
      if (sizeName === 'medium') sizeValue = `calc( 7 * ${unit})`;
      if (sizeName === 'large') sizeValue = `calc(13 * ${unit})`;
      if (sizeName === 'xlarge') sizeValue = `calc(21 * ${unit})`;

      if (element === 'container') {
        return `
          width: ${sizeValue};
          height: ${sizeValue};
        `;
      } if (element === 'image') {
        return `
          width: calc(${sizeValue} - 5px);
          height: calc(${sizeValue} - 5px);
        `;
      } if (element === 'status') {
        let bottom = 0;
        let right = 0;
        let border = 1;
        if (sizeName === 'xsmall') {
          bottom = 0;
          right = 0;
          border = 1;
        } else if (sizeName === 'small') {
          bottom = 0;
          right = 0;
          border = 1;
        } else if (sizeName === 'medium') {
          bottom = 2;
          right = 1;
          border = 1;
        } else Eif (sizeName === 'large') {
          bottom = 8;
          right = 4;
          border = 2;
        } else if (sizeName === 'xlarge') {
          bottom = 16;
          right = 8;
          border = 2;
        }

        return `
          width: calc(${sizeValue} / 9);
          height: calc(${sizeValue} / 9);
          bottom: ${bottom}px;
          right: ${right}px;
          border: ${border}px solid #FFFFFF;
        `;
      } Eif (element === 'letter') {
        return `
          font-size: calc(0.8 * ${sizeValue});
        `;
      }
      return '';
    }

    export function avatarGroupItem(index, total, groupType, xDistance, yDistance) {
      let result;
      const circles = niceCircles(total);
      const circle = circles[index];
      const zIndex = (index % 2) === 0 ? 10 : 0;

      if (groupType === 'circle') {
        const hStep = xDistance;
        const vStep = yDistance;

        const left = (circle[0]) * hStep;
        const top = (circle[1]) * vStep;
        result = `
          top: ${top}px;
          left: ${left}px;
          z-index: ${zIndex * index};
        `;
      } else {
        const hStep = xDistance;
        const left = hStep * index;
        result = `
          top: 0px;
          left: ${left}px;
        `;
      }

      return result;
    }